- [HTTP request](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.AsymmetricDecryptResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.aspect)
- [Try it!](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#try-it)

**Full name**: projects.locations.keyRings.cryptoKeys.cryptoKeyVersions.asymmetricDecrypt

Decrypts data that was encrypted with a public key retrieved from `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/getPublicKey#google.cloud.kms.v1.KeyManagementService.GetPublicKey` corresponding to a `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion` with `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys#CryptoKey.FIELDS.purpose` ASYMMETRIC_DECRYPT.

### HTTP request

Choose an endpoint:
global europe-west6 us-east7 europe-west3 us-west8 europe-west9 me-central2 us-east1 us-west1 us-west3 us-central2 us-east4 us-west2 europe-west8 us-central1 us-west4 us-east5 us-south1 northamerica-northeast1 northamerica-northeast2 us in ca   
`POST https://cloudkms.googleapis.com/v1/{name=projects/*/locations/*/keyRings/*/cryptoKeys/*/cryptoKeyVersions/*}:asymmetricDecrypt`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The resource name of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion` to use for decryption. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `cloudkms.cryptoKeyVersions.useToDecrypt` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "ciphertext": string, "ciphertextCrc32c": string } ``` |

| Fields ||
|---|---|
| `ciphertext` | `string (https://developers.google.com/discovery/v1/type-format format)` Required. The data encrypted with the named `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion`'s public key using OAEP. A base64-encoded string. |
| `ciphertextCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional. An optional CRC32C checksum of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext`. If specified, `KeyManagementService` will verify the integrity of the received `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext` using this checksum. `KeyManagementService` will report an error if the checksum verification fails. If you receive a checksum error, your client should verify that CRC32C(`https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext`) is equal to `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext_crc32c`, and if so, perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |

### Response body

Response message for `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#google.cloud.kms.v1.KeyManagementService.AsymmetricDecrypt`.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "plaintext": string, "plaintextCrc32c": string, "verifiedCiphertextCrc32c": boolean, "protectionLevel": enum (`https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel`) } ``` |

| Fields ||
|---|---|
| `plaintext` | `string (https://developers.google.com/discovery/v1/type-format format)` The decrypted data originally encrypted with the matching public key. A base64-encoded string. |
| `plaintextCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Integrity verification field. A CRC32C checksum of the returned `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.AsymmetricDecryptResponse.FIELDS.plaintext`. An integrity check of `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.AsymmetricDecryptResponse.FIELDS.plaintext` can be performed by computing the CRC32C checksum of `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.AsymmetricDecryptResponse.FIELDS.plaintext` and comparing your results to this field. Discard the response in case of non-matching checksum values, and perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |
| `verifiedCiphertextCrc32c` | `boolean` Integrity verification field. A flag indicating whether `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext_crc32c` was received by `KeyManagementService` and used for the integrity verification of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext`. A false value of this field indicates either that `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext_crc32c` was left unset or that it was not delivered to `KeyManagementService`. If you've set `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/asymmetricDecrypt#body.request_body.FIELDS.ciphertext_crc32c` but this field is still false, discard the response and perform a limited number of retries. |
| `protectionLevel` | ``enum (`https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel`)`` The `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel` of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion` used in decryption. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloudkms`
- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).